import re

def urlize(text):
    
    regex = r"(?i)\b((?:https?://|www\d{0,3}[.]|[a-z0-9.\-]+[.][a-z]{2,4}/)(?:[^\s()<>]+|\(([^\s()<>]+|(\([^\s()<>]+\)))*\))+(?:\(([^\s()<>]+|(\([^\s()<>]+\)))*\)|[^\s`!()\[\]{};:'\".,<>?«»“”‘’]))"
    urls = []
    for url in re.findall(regex,text):
        urls.append(url[0])
    doi_regex = r"10[.]\d{4,9}[/][\w|.|/|-]+[a-zA-Z0-9]"

    for doi in re.findall(doi_regex,text):
        urls.append(doi[0])

    return urls



